/*
 * Read/write PBP data
 * part of the Host-Toolkit library
 */

#include <stdio.h>
#include "tkhost.h"
#include "tkh.h"
#include "tkiocomm.h"

PBPDATA * read_pbpdata(int rnum)
{
  FILE *handle;
  PBPDATA *str;

  handle=mkopen("grey.hst",true,'r');
  if (!handle) return NULL;

  if (rnum>NUM_RACES || rnum<1) {
    fclose(handle);
    return NULL;
  }

  str=new PBPDATA;
  if (!str) {
    fclose(handle);
    return NULL;
  }

  fseek(handle,1800+(rnum-1),SEEK_SET);
  str->PBP=readUB2(handle);

  fclose(handle);
  return str;
}

PBPDATA *read_all_pbpdata()
{
  FILE *handle;
  PBPDATA *str;
  int vnum;

  handle=mkopen("grey.hst",true,'r');
  if (!handle) return NULL;

  str=new PBPDATA [12];
  if (!str) {
    fclose(handle);
    return NULL;
  }

  fseek(handle,1800,SEEK_SET);
  for(vnum=1;vnum<=11;vnum++) {
    str[vnum].PBP=readUB2(handle);
  }

  fclose(handle);
  return str;
}

bool write_pbpdata(int rnum,PBPDATA *str)
{
  FILE *handle;
  bool v;

  handle=mkopen("grey.hst",true,'w');
  if (!handle) return false;

  if (rnum>NUM_RACES || rnum<1) {
    fclose(handle);
    return false;
  }

  fseek(handle,1800+(rnum-1),SEEK_SET);
  v=writeUB2(handle,str->PBP);

  fclose(handle);
  return v;
}
