/*
 * Read/write RCONFIG data
 * part of the Host-Toolkit library
 */

#include <stdio.h>
#include "tkhost.h"
#include "tkh.h"
#include "tkiocomm.h"

RCONFIG *read_rconfig()
{
  FILE *handle;
  RCONFIG *str;
  int k;

  handle=mkopen("refdata.hst",false,'r');
  if (!handle) return NULL;

  str=new RCONFIG;
  if (!str) {
    fclose(handle);
    return NULL;
  }

  str->wScenarioActive=readUB2(handle);
  str->wMasterScenario=readUB2(handle);
  fseek(handle,6,SEEK_SET);
  for (k=1;k<12;k++) {
    str->wHomeworld[k]=readUB2(handle);
  }
  fseek(handle,30,SEEK_SET);
  for (k=1;k<12;k++) {
    str->wTantalusTurnsOwned[k]=readUB2(handle);
  }
  str->wTantalusPlanet=readUB2(handle);
  str->wTantalusTurnsNeeded=readUB2(handle);
  str->wOldEmpire=readUB2(handle);
  str->wScenario=readUB2(handle);
  fseek(handle,64,SEEK_SET);
  for (k=1;k<12;k++) {
    str->lScore[k]=readSB4(handle);
  }
  fseek(handle,156,SEEK_SET);
  str->lScoreNeeded=readUB4(handle);
  fseek(handle,164,SEEK_SET);
  str->wWinner=readUB2(handle);

  fclose(handle);
  return str;
}

bool write_rconfig(RCONFIG *str)
{
  FILE *handle;
  int k;
  bool v;

  handle=mkopen("refdata.hst",false,'w');
  if (!handle) return false;

  v=writeUB2(handle,str->wScenarioActive);
  v=writeUB2(handle,str->wMasterScenario);
  if (v) v=writeUB2(handle,0);
  for (k=1;k<12;k++) {
    if (v) v=writeUB2(handle,str->wHomeworld[k]);
  }
  if (v) v=writeUB2(handle,0);
  for (k=1;k<13;k++) {
    if (v) v=writeUB2(handle,str->wTantalusTurnsOwned[k]);
  }
  if (v) v=writeUB2(handle,str->wTantalusPlanet);
  if (v) v=writeUB2(handle,str->wTantalusTurnsNeeded);
  if (v) v=writeUB2(handle,str->wOldEmpire);
  if (v) v=writeUB2(handle,str->wScenario);
  if (v) v=writeUB2(handle,0);
  if (v) v=writeUB2(handle,0);
  for (k=1;k<13;k++) {
    if (v) v=writeUB4(handle,str->lScore[k]);
  }
  for (k=1;k<24;k++) {
    if (v) v=writeUB2(handle,0);
  }
  if (v) v=writeUB4(handle,str->lScoreNeeded);
  if (v) v=writeUB2(handle,0);
  if (v) v=writeUB4(handle,str->wWinner);

  fclose(handle);
  return v;
}
