/*
 * Read/write scanned ship data
 * part of the Host-Toolkit library
 */

#include <stdio.h>
#include "tkhost.h"
#include "tkh.h"
#include "tkiocomm.h"

SHIPXY *read_shipxy(int snum)
{
  FILE *handle;
  SHIPXY *str;

  handle=mkopen("shipxy.hst",false,'r');
  if (!handle) return NULL;

  if (snum>MAXSHIP || snum<1) {
    fclose(handle);
    return NULL;
  }

  fseek(handle,8*(snum-1),SEEK_SET);

  str=new SHIPXY;
  if (!str) {
    fclose(handle);
    return NULL;
  }

  str->pos.x=readUB2(handle);
  str->pos.y=readUB2(handle);
  str->wOwner=readUB2(handle);
  str->wMass=readUB2(handle);

  fclose(handle);
  return str;
}

bool write_shipxy(int snum,SHIPXY *str)
{
  FILE *handle;
  bool v;

  handle=mkopen("shipxy.hst",false,'w');
  if (!handle) return false;

  if (snum>MAXSHIP || snum<1) {
    fclose(handle);
    return false;
  }

  fseek(handle,8*(snum-1),SEEK_SET);

  v=writeUB2(handle,str->pos.x);
  if (v) v=writeUB2(handle,str->pos.y);
  if (v) v=writeUB2(handle,str->wOwner);
  if (v) v=writeUB2(handle,str->wMass);

  fclose(handle);
  return str;
}

SHIPXY * read_all_shipxy()
{
  FILE *handle;
  SHIPXY *str;
  int snum;

  handle=mkopen("shipxy.hst",false,'r');
  if (!handle) return NULL;

  str=new SHIPXY [501];
  if (!str) {
    fclose(handle);
    return NULL;
  }

  fseek(handle,2,SEEK_SET);

  for (snum=1;snum<=500;snum++) {
    str[snum].pos.x=readUB2(handle);
    str[snum].pos.y=readUB2(handle);
    str[snum].wOwner=readUB2(handle);
    str[snum].wMass=readUB2(handle);
  }

  fclose(handle);
  return str;
}
