/*
 * Read/write outgoing messages
 * part of the Player-Toolkit package
 */

#include <stdio.h>
#include "tkplayer.h"
#include "tkp.h"
#include "tkiocomm.h"

int num_outmess()
{
  FILE *handle;
  int ns;

  handle=mkopen("mess&p.dat",false,'r');
  if (!handle) return 0;

  ns=(int)readUB2(handle);
  fclose(handle);
  return ns;
}

OUTMESS *read_outmess(int mnum)
{
  FILE *handle;
  OUTMESS *str;
  UB2 ns;

  handle=mkopen("mess&p.dat",false,'r');
  if (!handle) return NULL;

  ns=readUB2(handle);
  if (mnum>ns || mnum==0) {
    fclose(handle);
    return NULL;
  }

  fseek(handle,2+10*(mnum-1),SEEK_SET);

  str=new OUTMESS;
  if (!str) {
    fclose(handle);
    return NULL;
  }

  str->lOffset=readUB4(handle);
  str->wLength=readUB2(handle);
  str->iFrom=readUB2(handle);
  str->iTo=readUB2(handle);

  fseek(handle,str->lOffset-1,SEEK_SET);

  str->sMessage=readXStringD(handle,str->wLength);

  fclose(handle);
  return str;
}

bool del_outmess(int mnum)
{
  FILE *handle;
  OUTMESS *str;
  UB2 ns;
  bool v;

  str=read_outmess(mnum);
  if (!str) return false;

  handle=mkopen("mess&p.dat",false,'w');
  if (!handle) return false;

  ns=readUB2(handle);
  ns--;
  fseek(handle,0,SEEK_SET);
  v=writeUB2(handle,ns);

  if (mnum<=ns) {
    fseek(handle,2+10*(mnum-1),SEEK_SET);

    if (v) v=writeUB4(handle,str->lOffset);
    if (v) v=writeUB2(handle,str->wLength);
    if (v) v=writeUB2(handle,str->iFrom);
    if (v) v=writeUB2(handle,str->iTo);
  }

  fclose(handle);
  return str;
}

OUTMESS *read_all_outmess()
{
  FILE *handle;
  OUTMESS *str;
  int mnum,mmax;
  fpos_t pos;

  mmax=num_outmess();
  if (mmax==0) return NULL;

  handle=mkopen("mess&p.dat",true,'r');
  if (!handle) return NULL;

  str=new OUTMESS [mmax+1];
  if (!str) {
    fclose(handle);
    return NULL;
  }

  fseek(handle,2,SEEK_SET);

  for(mnum=1;mnum<=mmax;mnum++) {
    str[mnum].lOffset=readUB4(handle);
    str[mnum].wLength=readUB2(handle);
    str[mnum].iFrom=readUB2(handle);
    str[mnum].iTo=readUB2(handle);

    pos=ftell(handle);
    fseek(handle,str[mnum].lOffset-1,SEEK_SET);
    str[mnum].sMessage=readXStringD(handle,str[mnum].wLength);
    fseek(handle,pos,SEEK_SET);
  }

  fclose(handle);
  return str;
}

bool write_outmess(int mnum,OUTMESS *str)
{
  FILE *handle;
  UB2 ns;
  bool v;


  handle=mkopen("mess&p.dat",false,'w');
  if (!handle) return NULL;

  str->wLength=str->sMessage.Len();

  ns=readUB2(handle);
  if (mnum>ns || mnum==0) {
    mnum=++ns;
    fseek(handle,0,SEEK_SET);
    v=writeUB2(handle,ns);
    fseek(handle,0,SEEK_END);
  } else {
    UB4 oo;
    UB2 olen;
    fseek(handle,2+10*(mnum-1),SEEK_SET);
    oo=readUB4(handle);
    olen=readUB2(handle);
    if (olen<str->wLength) {
      fseek(handle,0,SEEK_END);
    } else {
      fseek(handle,oo-1,SEEK_SET);
    }
    v=true;
  }
  str->lOffset=ftell(handle)+1;

  if (v) v=writeXStringD(handle,str->wLength,str->sMessage);

  fseek(handle,2+10*(mnum-1),SEEK_SET);

  if (v) v=writeUB4(handle,str->lOffset);
  if (v) v=writeUB2(handle,str->wLength);
  if (v) v=writeUB2(handle,str->iFrom);
  if (v) v=writeUB2(handle,str->iTo);

  fclose(handle);
  return v;
}
